# kmg-SADE

![KMG-Logo](templates/img/logo.svg "KMG Logo")

## About

Klaus Mollenhauer Gesamtausgabe is a digital edition presenting the published
works of Klaus Mollenhauer, as well as selected parts of his literary estate.

This repo contains the project website's technical infrastructure.
It is a fork of [SADE/SADE](https://gitlab.gwdg.de/SADE/SADE),
adapted according to the project's requirements.

It serves as XAR package according to the [EXPath Packaging System](http://expath.org/spec/pkg)
and is created as an application for [eXist-db](https://exist-db.org).

## Build

Prerequisites:

- ant >= 1.10.0
- npm

1. Install the dependencies:

    ```sh
      npm ci
    ```

1. Create the assets:

    ```sh
      npm run build
    ```

1. Build the `.xar`-file (output to `/.build`):

    ```sh
      ant test
    ```

## Run

Start the local instance:

```sh
  bash test/eXist-db-5.2.0/bin/startup.sh
```

Guide your favorite browser to the [eXist-db dashboard](http://localhost:8080/).

## Zotero API

To run the Zotero API locally (e.g. for displaying references in edition view) you have to start the exist database and open `db/app/zoteroapi/config.xml` in eXide. Paste in the values for `zotero.userOrGroupID` ("2206325") and `zotero.APIKey` (you have to know the APIKey).
After that, open the file `db/app/zoteroapi/modules/zoteroscheduler.xq` and launch the script (button "Eval" in the menubar of eXide). It takes a while to create the references, the script confirms it's run with the message `<true/>` in the terminal of eXide (the references are stored in `db/app/zoteroapi/zoterodata/json`).

## Search functionality

The search functionality is a React component integrated as part of the project JS.
To run it locally, download ElasticSearch 6 ([Link](https://www.elastic.co/de/downloads/past-releases#elasticsearch)) and run it via:

```
  ./bin/elasticsearch
```

To change the components of the search, you have to start the React development locally via node.
Uncomment line `<script type="text/javascript" src="http://localhost:4000/app.js"/>` in `templates/page_index.html`
and follow the instructions in `search/README.md`.

### Port settings

When port 8080 is blocked by a different service, set different ones
and restart the database:

```sh
sed -i 's/"8080"/"8090"/g; s/"8443"/"8444"/g' \
  test/eXist-db-4.5.0/tools/jetty/etc/jetty-http.xml \
  test/eXist-db-4.5.0/tools/jetty/etc/jetty.xml \
  test/eXist-db-4.5.0/tools/jetty/etc/jetty-ssl.xml
```

## Changelog

[Read the changelog.](CHANGELOG.md)

## Releases

tbd
## Contribute

tbd

## License

tbd
## Contact

tbd
