# Search interface

The Search on the KMG platform is implemented as a set of React components.
It is based on the implementation for the search in the project [Architrave](https://architrave.eu/)
from Moritz Schepp and was extended by Florian Barth.

The components request search results and translations via AJAX from
eXist-db endpoints. A few lines of CSS is included within the components.

The entrypoints are two components: ArchSearchForm and ArchSearchResults are
both loaded onto the `search.html` page into `.arch-search-form` and
`.` respectively. All changes to the search criteria are
first pushed to the url hash fragment which in turn triggers fetching the
results. This makes searches "linkable".

## Backend

The endpoints are

* /api.json?action=search-editions
* /api.json?action=search-people
* /api.json?action=search-works
* /api.json?action=search-pages

Each allowing additional parameters for `page`, `per_page`, `terms` and
`locale`. You can find the implementation in `/modules/api.xq`.

## Frontend development

The components are built with webpack so a reasonably new nodejs is required.
Developed and tested with nodejs v14.15.4 Newer version should work, to install
a specfic version of nodejs use [nvm](https://github.com/nvm-sh/nvm).
Required npm modules need to be installed with:

    `npm install`

After that, you have to run once:

    `npm run build`

Then you can start the dev server via:

    `npm run dev`
    (This is a script for `npm run webpack-dev-server`)

You may want to change `page_index.html` to include the dev server's app.js file so
that changes are reflected immediately within eXist-db. For that, in `page_index.html`
comment in the line:

    `<script type="text/javascript" src="http://localhost:4000/app.js"/>`


## Frontend deployment

Changes can be deployed to the project by building the frontend part:
    `npm run build`
    (This is a script that runs `npm run webpack-cli --mode=production && cp public/app.js ../templates/js/search.js`; all js from app.js is copied to search.js)
