const menu = document.querySelector('.edition-nav-controls');
const editions = document.querySelectorAll('toggle-section');
const display = document.querySelector('.edition-nav-data');
let formData = {};

const isInParam = function isInParam(parameter, value) {
  let result;
  if (parameter === 'all') {
    result = true;
  } else {
    const params = parameter.split(' ');
    const values = value.split(' ');
    result = values.some((item) => params.includes(item));
  }
  return result;
};

const sortEditions = function sortEditions(sortBy, direction) {
  const edArray = [...editions];
  if (sortBy === 'alph' && direction === 'asc') {
    edArray.sort((a, b) => a.id.toLowerCase() - b.id.toLowerCase()).forEach(e => display.appendChild(e));
  } else if (sortBy === 'alph' && direction === 'desc') {
    edArray.sort((b, a) => a.id.localeCompare(b)).forEach(e => display.appendChild(e));
  } else if (direction === 'asc') {
    edArray.sort((a, b) => a.dataset.year - b.dataset.year).forEach(e => display.appendChild(e));
  } else {
    edArray.sort((b, a) => a.dataset.year - b.dataset.year).forEach(e => display.appendChild(e));
  }
};

const updateSelection = function selectView() {
  const newFormData = Object.fromEntries(new FormData(menu));

  if (newFormData.sort === formData.sort) {
    editions.forEach(e => {
      const inDecade = isInParam(newFormData.decade, e.dataset.year.substring(2, 3));
      const inKeywords = isInParam(newFormData.keyword, e.dataset.keywords);
      const inGenre = isInParam(newFormData.genre, e.dataset.genre);
      if (inDecade && inKeywords && inGenre) {
        e.classList.remove('hidden');
      } else {
        e.classList.add('hidden');
      }
    });
  } else {
    const sortParams = newFormData.sort.split('-');
    sortEditions(sortParams[0], sortParams[1]);
  }
  formData = newFormData;
};

if (menu) {
  formData = Object.fromEntries(new FormData(menu));
  menu.addEventListener('change', updateSelection);
}
