const indexControls = document.querySelector('.index-controls');

const updateIndexView = function updateIndexVier() {
  const formData = Object.fromEntries(new FormData(indexControls));
  const indexes = document.querySelectorAll('[data-indextype]');
  const entries = document.querySelectorAll('.js-editorial-info--person');
  indexes.forEach((index) => {
    if (index.dataset.indextype === formData.type) {
      index.classList.remove('hidden');
    } else {
      index.classList.add('hidden');
    }
  });
  entries.forEach((entry) => {
    if (formData.letter) {
      if (entry.dataset.letter === formData.letter) {
        entry.classList.remove('hidden');
      } else {
        entry.classList.add('hidden');
      }
    } else {
      entry.classList.remove('hidden');
    }
  });
};

if (indexControls) {
  document.addEventListener('DOMContentLoaded', updateIndexView);
  indexControls.addEventListener('change', updateIndexView);
}
